function [Yout BackDye]=AutoBackgroundRemove_2p3(predata,data,wl,T1,T2,T3,T4,CosmicRemove,cosmicthres,figs,savepath)
% The exact name of the variables might differ slightly from the steps explained in
% the article.

%% Finding anchorpoints with the gradient threshold T1

data1(data>T1)=1;
data1(data<-T1)=-1;
data1(data<T1 & data>-T1)=0;

absdata1=abs(data1);

if figs==1
    figure;plot(data);
    hold on;plot(data1*T1,'r');title('1-function')
    legend('spectra','data1*T1')
end

aa=absdata1(2:end)-absdata1(1:end-1);
bb=absdata1(1:end-1)-absdata1(2:end);

data2=data1;
data2(find(aa==-1)+1)=2;
data2(find(bb==-1))=2;
data3=data2(2:end)-data2(1:end-1);
data3=[0 data3];
%pre- begin end of feature
data3(data3~=2 & data3~=-2)=0;
% data3(data3~=-2)=0;
cc=find(data3~=0);
anchor=zeros(1,length(data));
anchor(cc)=predata(cc);
ccdata=data3(cc);

xscale=1:1340;
if figs==1
    figure;
    plot(xscale,absdata1,'-o',xscale,data2,'-o',xscale,data3,'-o')
    legend('absdata1','data2','data3')
    title('1b')
end

if figs==1
    figure;
    plot(ccdata)
    title('2-values2atPreanchor')
    
    % figure;plot(data2);title('function')
    % hold on; plot(data3,'or');title('function')
    figure;plot(predata./max(predata));
    hold on;plot(data./max(data),'r');
    hold on;plot(data3,'g')
    hold on;plot(T1*ones(1,length(data))/max(data),'g')
    hold on;plot(-T1*ones(1,length(data))/max(data),'g')
    hold on;plot(anchor./max(predata));
    title('3-dataGradPreanchor')
    %  hold on;plot(data2,'k')
    % hold on;plot(data1,'b')
    
    figure;plot(data)
    hold on;plot(T1*ones(1,length(data)))
    hold on;plot(-T1*ones(1,length(data)))
    title('4-GradPreanchor')
end


%% removing errors from anchor points
% errors=data3(1:end-1)+data3(2:end);
errors=ccdata(1:end-1)+ccdata(2:end);


if figs==1
    figure;plot(errors);
    title('5-errors')
end

nerror=find(errors==-4);
perror=find(errors==4)+1;
nperror=sort([nerror perror]);
ccnperror=cc(nperror);

data4=data3;
data4(ccnperror)=0;

%% Apply the fine structure threshold T2

pp0=find(data4==2);
nn0=find(data4==-2);

BackDye=zeros(1,length(predata));

if figs==2
    h=figure;
    subpl_relpos(1,:)=[1/5 2/6 3/5 3/6];
    subpl_sizecm=[7 7];
    set(gcf, 'PaperPosition', Printer_subplot_Mig(subpl_relpos,subpl_sizecm));
    subplot('Position',subpl_relpos(1,:))
    plot(wl,predata,'-','Color','k','LineWidth',1)
    hold on
    plot(wl(pp0),predata(pp0),'xb','MarkerSize',4,'LineWidth',1)
    hold on
    plot(wl(nn0),predata(nn0),'xr','MarkerSize',4,'LineWidth',1)
    axis tight
    set(gca,'FontSize',8)
    % set(gca,'YAxisLocation','right')
    % set(gca,'XTick',[1.5:2:9.5])
    % set(gca,'XTickLabel',{'2','4','6','8','10'})
    xlabel('Wavelength (nm)')
    % set(gca,'XTickLabel','')
    % set(gca,'YTick',[0 5E4 10E4])
    ylabel('CCD counts')
    % LEG=legend('S','onset anchor','end anchor')
    % set(LEG,'FontSize',5)
    % set(LEG,'Location','NorthEast')
    %         print(h,'-dtiff','-r300',[savepath 'Imageq'])
    
    h=figure;
    subpl_relpos(1,:)=[1/5 2/6 3/5 3/6];
    subpl_sizecm=[7 7];
    set(gcf, 'PaperPosition', Printer_subplot_Mig(subpl_relpos,subpl_sizecm));
    subplot('Position',subpl_relpos(1,:))
    %         plot(wl,data,'-','Color','g','LineWidth',1)
    plot(wl,data,'-','Color',[0 0.5 0],'LineWidth',1)
    hold on
    plot(wl(pp0),data(pp0),'xb','MarkerSize',4,'LineWidth',1)
    hold on
    plot(wl(nn0),data(nn0),'xr','MarkerSize',4,'LineWidth',1)
    hold on;plot(wl,T1*ones(1,length(data)),'--k')
    set(gca,'FontSize',8)
    hold on;plot(wl,-T1*ones(1,length(data)),'--k')
    axis tight
    set(gca,'FontSize',8)
    % set(gca,'YAxisLocation','right')
    % set(gca,'XTick',[1.5:2:9.5])
    % set(gca,'XTickLabel',{'2','4','6','8','10'})
    % set(gca,'XTickLabel','')
    xlabel('Wavelength (nm)')
    % set(gca,'YTick',[0 5E4 10E4])
    ylabel('\Deltay / \Deltax ')
    % LEG=legend('gradient','start of feature','end of feature','threshold')
    %print(h,'-dtiff','-r300',[savepath 'Imagew'])
    
    h=figure;
    subpl_relpos(1,:)=[1/5 2/6 3/5 3/6];
    subpl_sizecm=[7 7];
    set(gcf, 'PaperPosition', Printer_subplot_Mig(subpl_relpos,subpl_sizecm));
    subplot('Position',subpl_relpos(1,:))
    plot(wl,abs(data),'-','Color',[0 0.5 0.5],'LineWidth',1)
    set(gca,'FontSize',8)
    axis tight
    set(gca,'FontSize',8)
    % set(gca,'YAxisLocation','right')
    % set(gca,'XTick',[1.5:2:9.5])
    % set(gca,'XTickLabel',{'2','4','6','8','10'})
    % set(gca,'XTickLabel','')
    xlabel('Wavelength (nm)')
    % set(gca,'YTick',[0 5E4 10E4])
    ylabel(' |\Deltay / \Deltax | ')
    % LEG=legend('gradient','start of feature','end of feature','threshold')
    %print(h,'-dtiff','-r300',[savepath 'Imagee'])
end


if length(pp0)~=0 & length(nn0)~=0
    if nn0(1)<pp0(1)
        nn0(1)=[];
    end
    
    if pp0(end)>nn0(end)
        pp0(end)=[];
    end
    
    if figs==1
        figure;
        plot(pp0,'-ob')
        hold on
        plot(nn0,'-or')
        legend('positive','negative')
        title('6- values Pre 2 and -2')
        
        %         figure;
        %         plot(predata(nn0)-predata(pp0))
        %          title('7- difference Pre -2 and 2')
    end
    
    
    pp=pp0(2:end);
    nn=nn0(1:end-1);
    
    wl_pp=wl(pp);
    wl_nn=wl(nn);
    
    wn_pp=1E7./wl_pp;
    wn_nn=1E7./wl_nn;
    
    
    T2d=T2;
    
    
    vv=wn_nn-wn_pp;
    
    
    AA=find(vv>T2d);
    PP=pp(AA);
    NN=nn(AA);
    AN=[pp0(1) PP NN nn0(end)];
    Anchor=sort(AN);
    
    if figs==1
        figure;
        plot(pp,'-ob')
        hold on
        plot(nn,'-or')
        hold on
        plot(vv,'-og')
        hold on
        plot(T2d*ones(1,length(vv)))
        legend('start feature','end feature','diff. wavenumber')
        title('8- End-Start to consider')
        
        
        figure;
        
        plot(PP,'-ob')
        hold on
        plot(NN,'-or')
        legend('start feature','end feature')
        title('9- End-Start non fine-structure')
        
        figure;
        plot(Anchor,'o')
        title('A')
        title('10- non fine-structure anchors')
    end
    
    Anchor2=[1 Anchor 1340];
    
    %% eliminate the filter feature.
    if Anchor(2)-Anchor(1)>=T3
        linesubs(1:Anchor(2))=predata(Anchor(2));
        difference=predata(1:Anchor(2))-linesubs(1:Anchor(2));
        newanchors=(find(difference>0));
        Anchor2(2)=newanchors(1);
    else
        Anchor2([2 3])=[];
    end
    
    
    %%     eliminate the cosmic ray
    if CosmicRemove==1
        mm=find(data(Anchor2(2):end)>cosmicthres);
        if length(mm)~=0
            % new cosmic ray code
            mmmax=find(data==max(data(mm)))
            mm2=sort([Anchor2 mmmax(1)])
            mm2pos=find(mm2==mmmax(1))
            Anchor2(mm2pos:mm2pos+1)=[];
        end
    end
    
    %% 
    Anchorpl=zeros(1,length(data));
    Anchorpl(Anchor2)=predata(Anchor2);
    
    if figs==1
        figure;plot(predata);
        hold on; plot(Anchorpl,'g')
        title('11- final anchorpoints+1+1340')
    end
    
    xq=1:1340;
    subtractpoints= predata(Anchor2);
    vq2 = interp1(Anchor2,subtractpoints,xq);
    
%     if figs==1
%         %     figure;
%         %     plot(xq,vq2,xq,predata)
%         %     title('12- cutting region from anchors+1+1340')
%     end
    
    
 %% Calculate and output the background subtracted spectra  
    
    for ii=1:1:length(Anchor2)-1
        if mod(ii,2)
            %    disp('odd')
            BackDye(Anchor2(ii):Anchor2(ii+1))= predata(Anchor2(ii):Anchor2(ii+1));
        else
            %    disp('even')
            BackDye(Anchor2(ii):Anchor2(ii+1))= vq2(Anchor2(ii):Anchor2(ii+1));
        end
    end
    

    
    Yout=predata-BackDye;
    
    
 
    
else
    Yout=zeros(1,length(predata));
    BackDye=predata;
end

if sum(Yout)<T4
    Yout=zeros(1,length(predata));
end

Yout(Yout<0)=0;


%%
if figs==1
    figure;
    plot(wl,Yout,'-')
    title('13- output spectra')

    figure;
    %     plot(wl,BackDye,'-',wl,Yout)
    area([BackDye' Yout' ])
    title('14- output spectra')
    
    figure;
    plot(wl,BackDye,'-',wl,Yout)
    %   area([ Yout' BackDye' ])
    title('15- output spectra')   
end

if figs==2
    h=figure;
    subpl_relpos(1,:)=[1/5 2/6 3/5 3/6];
    subpl_sizecm=[7 7];
    set(gcf, 'PaperPosition', Printer_subplot_Mig(subpl_relpos,subpl_sizecm));
    subplot('Position',subpl_relpos(1,:))
    %         plot(data,'-','Color','k','LineWidth',1)
    %         plot(wl,BackDye,'r',wl,predata,'-k','LineWidth',1)
    plot(wl,BackDye,'r','LineWidth',2)
    hold on
    plot(wl,predata,'-k','LineWidth',1)
    hold on
    plot(wl(Anchor2(2:2:end-1)),predata(Anchor2(2:2:end-1)),'ob','MarkerSize',4,'LineWidth',1)
    hold on
    plot(wl(Anchor2(3:2:end-1)),predata(Anchor2(3:2:end-1)),'or','MarkerSize',4,'LineWidth',1)
    hold on
    plot(wl(Anchor2(1)),predata(Anchor2(1)),'sr','MarkerSize',4,'LineWidth',1)
    hold on
    plot(wl(Anchor2(end)),predata(Anchor2(end)),'sb','MarkerSize',4,'LineWidth',1)
    axis tight
    set(gca,'FontSize',8)
    % set(gca,'YAxisLocation','right')
    % set(gca,'XTick',[1.5:2:9.5])
    % set(gca,'XTickLabel',{'2','4','6','8','10'})
    % set(gca,'XTickLabel','')
    % set(gca,'YTick',[0 5E4 10E4])'
    xlabel('Wavelength (nm)')
    ylabel('CCD counts')
    % LEG=legend('cut','raw data','start of feature','end of feature','added anchors')
    %print(h,'-dtiff','-r300',[savepath 'ImageREPEAT'])
    
    h=figure;
    subpl_relpos(1,:)=[1/5 2/6 3/5 3/6];
    subpl_sizecm=[7 7];
    set(gcf, 'PaperPosition', Printer_subplot_Mig(subpl_relpos,subpl_sizecm));
    subplot('Position',subpl_relpos(1,:))
    plot(wl,BackDye,'-r',wl,Yout,'b','LineWidth',1)
    axis tight
    set(gca,'FontSize',8)
    % set(gca,'YAxisLocation','right')
    % set(gca,'XTick',[1.5:2:9.5])
    % set(gca,'XTickLabel',{'2','4','6','8','10'})
    % set(gca,'XTickLabel','')
    % set(gca,'YTick',[0 5E4 10E4])'
    xlabel('Wavelength (nm)')
    ylabel('CCD counts')
    % LEG=legend('F18 signal','Tb signal')
    %print(h,'-dtiff','-r300',[savepath 'Imaget'])
    
end




